Index: /trunk/gsdl/perllib/plugins/TEXTPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/TEXTPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/TEXTPlug.pm	(revision 10218)
@@ -59,19 +59,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "TEXTPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
 
-    if (!parsargv::parse(\@_, 
-			 q^title_sub/.*/^, \$self->{'title_sub'},
-			 "allow_extra_options")) {
-	print STDERR "\nIncorrect options passed to TEXTPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-        die "\n";
-    }
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
 
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/UnknownPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/UnknownPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/UnknownPlug.pm	(revision 10218)
@@ -58,4 +58,7 @@
 use BasPlug;
 use parsargv;
+#$%^
+use parse2;
+
 
 
@@ -94,21 +97,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "UnknownPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_, 
-			 q^assoc_field/.*/^, \$self->{'assoc_field'},
-			 q^file_format/.*/^, \$self->{'file_format'},
-			 q^mime_type/.*/^, \$self->{'mime_type'},
-			 q^process_extension/.*/^, \$self->{'process_extension'},
-			 "allow_extra_options")) {
-	print STDERR "\nIncorrect options passed to UnknownPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-        die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     # "-process_extension" is a simpler alternative to -process_exp for non-regexp people
Index: /trunk/gsdl/perllib/plugins/W3ImgPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/W3ImgPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/W3ImgPlug.pm	(revision 10218)
@@ -225,35 +225,13 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new HTMLPlug ($class, @_);
-    $self->{'plugin_type'} = "W3ImgPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_,
-			 q^aggressiveness/\d/3^, \$self->{'aggressiveness'},
-			 q^index_pages^, \$self->{'index_pages'},
-			 q^no_cache_images^, \$self->{'no_cache_images'},
-			 q^min_size/\d*/2000^, \$self->{'min_img_filesize'},
-			 q^min_width/\d*/50^, \$self->{'min_img_width'},
-			 q^min_height/\d*/50^, \$self->{'min_img_height'},
-			 q^thumb_size/\d*/100^, \$self->{'thumbnail_size'},
-			 q^convert_params/.*/ ^, \$self->{'img_convert_param'},
-			 q^max_near_text/\d*/400^, \$self->{'maxtext'},
-			 q^min_near_text/\d*/10^, \$self->{'mintext'},
-			 q^smallpage_threshold/\d*/2048^, \$self->{'smallpage_threshold'},
-			 q^textrefs_threshold/\d*/2^, \$self->{'textref_threshold'},
-			 q^caption_length/\d*/80^, \$self->{'caption_len'},
-			 q^neartext_length/\d*/300^, \$self->{'neartext_len'},
-			 q^document_text^, \$self->{'document_text'},
-			 "allow_extra_options"
-			 )) { 
-
-	print STDERR "\nIncorrect options passed to W3ImgPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-    
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new HTMLPlug($pluginlist,$inputargs,$hashArgOptLists): new HTMLPlug($pluginlist,$inputargs);
+
     # init class variables
     $self->{'textref'} = undef; # init by read_file fn
@@ -399,11 +377,11 @@
     }
 
-    if ( $self->{'neartext_len'} > $self->{'maxtext'} ) {
-	$self->{'maxtext'} = $self->{'neartext_len'} * 1.33;
-	print {$self->{'outhandle'}} "W3ImgPlug: Warning: adjusted max_text to $self->{'maxtext'}\n";
+    if ( $self->{'neartext_length'} > $self->{'max_near_text'} ) {
+	$self->{'max_near_text'} = $self->{'neartext_length'} * 1.33;
+	print {$self->{'outhandle'}} "W3ImgPlug: Warning: adjusted max_text to $self->{'max_near_text'}\n";
     } 
-    if ( $self->{'caption_len'} > $self->{'maxtext'} ) {
-	$self->{'maxtext'} = $self->{'caption_len'} * 1.33;
-	print {$self->{'outhandle'}} "W3ImgPlug: Warning: adjusted max_text to $self->{'maxtext'}\n";
+    if ( $self->{'caption_length'} > $self->{'max_near_text'} ) {
+	$self->{'max_near_text'} = $self->{'caption_length'} * 1.33;
+	print {$self->{'outhandle'}} "W3ImgPlug: Warning: adjusted max_text to $self->{'max_near_text'}\n";
     }
 
@@ -492,5 +470,5 @@
     } else { ($crcid) = `cksum $filepath` =~ /^(\d+)/; }
     $thumbfp = "$tndir/tn_$crcid.jpg";
-    `convert -flatten -filter Hanning $self->{'img_convert_param'} -geometry "$self->{'thumbnail_size'}x$self->{'thumbnail_size'}>" $filepath $thumbfp` unless -e $thumbfp;
+    `convert -flatten -filter Hanning $self->{'convert_params'} -geometry "$self->{'thumb_size'}x$self->{'thumb_size'}>" $filepath $thumbfp` unless -e $thumbfp;
     if ( ! (-e $thumbfp) ) {
 	print STDERR "W3ImgPlug: 'convert' failed. Check ImageMagicK binaries are installed and working correctly\n"; return 0; 
@@ -532,5 +510,5 @@
 	    # textual references
 	    if ( $aggr  == 5 || $aggr >= 7) {
-		if ( length($relreltext) > ($self->{'caption_len'} * 2) )  {
+		if ( length($relreltext) > ($self->{'caption_length'} * 2) )  {
 		    $reltext .= $self->get_textrefs($relreltext, $textref, $prevpos, $imgs->{$id}{'pos'}, $nextpos); }
 		else {
@@ -610,5 +588,5 @@
 
     # extract larger context
-    $maxtext = $self->{'maxtext'};
+    $maxtext = $self->{'max_near_text'};
     $startpos = $pos - ($maxtext * 4);
     $context_size = $maxtext*10;
@@ -663,5 +641,5 @@
     }
     foreach $sentence ( keys %sentences ) {
-	if ($sentences{$sentence} < $self->{'textref_threshold'}) {
+	if ($sentences{$sentence} < $self->{'textrefs_threshold'}) {
 	    delete $sentences{$sentence};
 	}
@@ -681,9 +659,9 @@
 	$startpos, $context, $context_size);
     
-    $mintext = $self->{'mintext'};
-    $goodlen = $self->{'caption_len'};
+    $mintext = $self->{'min_near_text'};
+    $goodlen = $self->{'caption_length'};
 
     # extract a context to extract near text from (faster)
-    $context_size = $self->{'maxtext'}*3;
+    $context_size = $self->{'max_near_text'}*3;
     $startpos = $pos - ($context_size / 2);
     if ($startpos < $prevpos ) { $startpos = $prevpos }
@@ -762,10 +740,10 @@
     # if bound_tag too far from the image, then prob not caption
     # (note: have to allow for tags, so multiply by 3
-    if ( $etag && length($nt[0]) < ($self->{'caption_len'} * 3) ) { 
+    if ( $etag && length($nt[0]) < ($self->{'caption_length'} * 3) ) { 
 	if ( $nt[0] =~ /<\/$etag>/si ) {
 	    # the whole caption is above the image: <tag>text</tag><img>
 	    ($nt[0]) =~ /<(?:$etag)[\s]?.*?>(.*?)<\/$etag>/is;
 	    $nt[0] = $self->strip_tags($nt[0]);
-	    if ( length($nt[0]) > $self->{'mintext'} ) { 
+	    if ( length($nt[0]) > $self->{'min_near_text'} ) { 
 		$gotcap = 1;
 		$nt[1] = ""; 
@@ -776,5 +754,5 @@
 	    ($nt[1]) = $nt[1] =~ /(.*?)<\/$etag>/si;
 	    $nt[0] = $self->strip_tags($nt[0] . $nt[1]);
-	    if ( length($nt[0]) > $self->{'mintext'} ) { 
+	    if ( length($nt[0]) > $self->{'min_near_text'} ) { 
 		$gotcap = 2;
 		$nt[1] = "";
@@ -818,7 +796,7 @@
     $bestlen[0] = $bestlen[1] = 0; $bestlen[2] = $bdist = 999999;
     $best[0] = $best[1] = $best[2] = "";
-    $maxtext = $self->{'maxtext'};
-    $mintext = $self->{'mintext'};
-    $goodlen = $self->{'neartext_len'}; 
+    $maxtext = $self->{'max_near_text'};
+    $mintext = $self->{'min_near_text'};
+    $goodlen = $self->{'neartext_length'}; 
 
     # extract a context to extract near text from (faster)
@@ -945,7 +923,7 @@
     # either side of the tag (by word boundary)
     return "" if ( ! exists $imgs->{$fp}{'rawpos'} );
-    $startpos = $imgs->{$fp}{'rawpos'} - (($self->{'maxtext'} / 2) + 20);
+    $startpos = $imgs->{$fp}{'rawpos'} - (($self->{'max_near_text'} / 2) + 20);
     if ( $startpos < 0 ) { $startpos = 0 }
-    $rawtext = substr $self->{'plaintext'}, $startpos, $self->{'maxtext'} + 20;
+    $rawtext = substr $self->{'plaintext'}, $startpos, $self->{'max_near_text'} + 20;
     $rawtext =~ s/\s\s/ /g;
 
@@ -1010,7 +988,7 @@
 	}
 	$filesize = (-s $abspath);
-	if ( $filesize >= $self->{'min_img_filesize'} 
-	    && ( $width >= $self->{'min_img_width'} ) 
-	    && ( $height >= $self->{'min_img_height'} ) ) {
+	if ( $filesize >= $self->{'min_size'} 
+	    && ( $width >= $self->{'min_width'} ) 
+	    && ( $height >= $self->{'min_height'} ) ) {
 	    
 	   $imgs->{$filepath}{'exists'} = 1;
Index: /trunk/gsdl/perllib/plugins/WordPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/WordPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/WordPlug.pm	(revision 10218)
@@ -48,13 +48,14 @@
 
 sub new {
-    my $class = shift (@_);
-    
-    my $self = new ConvertToPlug ($class, @_);
-    $self->{'plugin_type'} = "WordPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
 
-    # wvWare will always produce html files encoded as utf-8
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new ConvertToPlug($pluginlist,$inputargs,$hashArgOptLists): new ConvertToPlug($pluginlist,$inputargs);
+
+     # wvWare will always produce html files encoded as utf-8
     if ($self->{'input_encoding'} eq "auto") {
 	$self->{'input_encoding'} = "utf8";
Index: /trunk/gsdl/perllib/plugins/XMLPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/XMLPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/XMLPlug.pm	(revision 10218)
@@ -28,4 +28,6 @@
 use BasPlug;
 use doc;
+#$%^
+use parse2;
 
 sub BEGIN {
@@ -57,22 +59,13 @@
 our ($self);
 sub new {
-    my $class = shift (@_);
-
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+    
     # $self is global for use within subroutines called by XML::Parser
-    $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "XMLPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-    
-    if (!parsargv::parse(\@_, 
-			 q^xslt/.*/^, \$self->{'xslt'},
-			 "allow_extra_options")) {
-
-	print STDERR "\nIncorrect options passed to XSLTPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
+    $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     my $parser = new XML::Parser('Style' => 'Stream',
@@ -82,8 +75,5 @@
 						'Doctype' => \&Doctype,
 						'Default' => \&Default
-						});
-
-    
-				
+						});  
     $self->{'parser'} = $parser;
 
Index: /trunk/gsdl/perllib/plugins/ZIPPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/ZIPPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/ZIPPlug.pm	(revision 10218)
@@ -43,5 +43,4 @@
 # tar (for tar) 
 
-# 12/05/02 Added usage datastructure - John Thompson
 
 package ZIPPlug;
@@ -51,4 +50,6 @@
 use util;
 use Cwd;
+#$%^
+use parse2;
 
 
@@ -71,23 +72,19 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ("ZIPPlug", @_);
-    $self->{'plugin_type'} = "ZIPPlug";
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_, 
-			 q^process_exp/.*/^, \$self->{'process_exp'},
-			 "allow_extra_options")) {
-	print STDERR "\nIncorrect options passed to ZIPPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-        die "\n";
-    }
+
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     # BasPlug is explicitly set not to set process_exp if recursive plugin
     # Not sure of this reasoning.  Want it to be set in ZIPPlug, so explicitly
     # pass it in as default value
+    
+    ## do we need this???? --kjdon
     if (!$self->{'process_exp'}) {
 	$self->{'process_exp'} = get_default_process_exp();
Index: /trunk/gsdl/perllib/printusage.pm
===================================================================
--- /trunk/gsdl/perllib/printusage.pm	(revision 10217)
+++ /trunk/gsdl/perllib/printusage.pm	(revision 10218)
@@ -101,4 +101,9 @@
 	}
 
+	# If the option has a charactor length field, display this
+	if (defined($option->{'char_length'})) {
+	    &gsprintf(STDERR, "      <Charactor Length>$option->{'char_length'}</Charactor Length>\n");
+	}
+
 	# If the option has a range field, display this
 	if (defined($option->{'range'})) {
@@ -125,14 +130,14 @@
 	    }
 
-	    # Special case for 'input_encoding'
-	    if ($optionname =~ m/^input_encoding$/i) {
-		my $e = $encodings::encodings;
-		foreach my $enc (sort {$e->{$a}->{'name'} cmp $e->{$b}->{'name'}} keys (%$e)) {
-		    &gsprintf(STDERR, "        <Value>\n");
-		    &gsprintf(STDERR, "          <Name>$enc</Name>\n");
-		    &gsprintf(STDERR, "          <Desc>$e->{$enc}->{'name'}</Desc>\n");
-		    &gsprintf(STDERR, "        </Value>\n");
-		}
-	    }
+#	    # Special case for 'input_encoding'
+#	    if ($optionname =~ m/^input_encoding$/i) {
+#		my $e = $encodings::encodings;
+#		foreach my $enc (sort {$e->{$a}->{'name'} cmp $e->{$b}->{'name'}} keys (%$e)) {
+#		    &gsprintf(STDERR, "        <Value>\n");
+#		    &gsprintf(STDERR, "          <Name>$enc</Name>\n");
+#		    &gsprintf(STDERR, "          <Desc>$e->{$enc}->{'name'}</Desc>\n");
+#		    &gsprintf(STDERR, "        </Value>\n");
+#		}
+#	    }
 
 	    &gsprintf(STDERR, "      </List>\n");
@@ -246,16 +251,16 @@
 	}
 
-	# Special case for 'input_encoding'
-	if ($optionname =~ m/^input_encoding$/i) {
-	    my $e = $encodings::encodings;
-	    foreach my $enc (sort {$e->{$a}->{'name'} cmp $e->{$b}->{'name'}} keys (%$e)) {
-		&gsprintf(STDERR, " " x $optiondescoffset);
-		&gsprintf(STDERR, "$enc:");
-
-		my $encodingdesc = $e->{$enc}->{'name'};
-		&display_text_in_column($encodingdesc, $optiondescoffset + 2,
-					$optiondescoffset + length("$enc:"), 80);
-	    }
-	}
+#	# Special case for 'input_encoding'
+#	if ($optionname =~ m/^input_encoding$/i) {
+#	    my $e = $encodings::encodings;
+#	    foreach my $enc (sort {$e->{$a}->{'name'} cmp $e->{$b}->{'name'}} keys (%$e)) {
+#		&gsprintf(STDERR, " " x $optiondescoffset);
+#		&gsprintf(STDERR, "$enc:");
+#
+#		my $encodingdesc = $e->{$enc}->{'name'};
+#		&display_text_in_column($encodingdesc, $optiondescoffset + 2,
+#					$optiondescoffset + length("$enc:"), 80);
+#	    }
+#	}
 
 	# Add a blank line to separate options
